#define versionx "19_DCF77_lcd_tst"
/*                **************** 
// OK
// programme écrit à partir de IntClockSync
// pins modifiés par rapport à l'exemple d'origine
// LCD 456789 au lieu de 426789 (GoodFields général) car la 2 est en interruption DCF

/*
 * InternalClockSync.pde
 * example code illustrating time synced from a DCF77 receiver
 * Thijs Elenbaas, 2012
 * This example code is in the public domain.
 
  This example shows how to fetch a DCF77 time and synchronize
  the internal clock. In order for this example to give clear output,
  make sure that you disable logging  from the DCF library. You can 
  do this by commenting out   #define VERBOSE_DEBUG 1   in Utils.cpp. 
 */

#include <Streaming.h>

// #define VERBOSE_DEBUG 1	     // Verbose = pour debug DCF, commenter si pas besoin
#include "DCF77.h"

#include "Time.h"    // Horloge ARDUINO
int attente_misalheure=0;
int previous_second=99;

#include <LiquidCrystal.h>
  LiquidCrystal lcd(4, 5, 6, 7, 8, 9);

/* Most Arduino boards have two external interrupts: 
numbers 0 (on digital pin 2) and 1 (on digital pin 3). 
The Arduino Mega has an additional four: numbers 2 (pin 21), 3 (pin 20), 4 (pin 19), and 5 (pin 18). 
*/
  
#define DCF_PIN 2	         // Connection pin to DCF 77 device
#define DCF_INTERRUPT 0		 // Interrupt number associated with pin

// #define led_a 13

time_t time;
//DCF77 DCF = DCF77(DCF_PIN,DCF_INTERRUPT,LOW);
DCF77 DCF = DCF77(DCF_PIN,DCF_INTERRUPT);


void setup() {
// définition taille du LCD :
  lcd.begin(16, 2);
  lcd.clear(); lcd.print (versionx);

  Serial.begin(9600); 
  Serial.println("Waiting for DCF77 time ... ");
  DCF.Start();
  Serial.println("It will take at least 2 minutes until a first update can be processed.");

  delay(1000);
  lcd.clear();
}

void loop() {
// attente
  do {
    delay(50);
  } while (second() == previous_second);
 previous_second = second();

   /*
  if (digitalRead(DCF_PIN)) {
    digitalWrite(led_a,HIGH);
  } else { 
    digitalWrite(led_a,HIGH);
  }  
*/
  time_t DCFtime = DCF.getTime(); // Check if new DCF77 time is available
  if (DCFtime!=0)
  {
    Serial << "Time is updated" << endl;
    setTime(DCFtime);
     lcd.setCursor( 9,1); lcd << "Synchro";
     attente_misalheure=0;
  } else {
     lcd.setCursor( 9,1); lcd << attente_misalheure << "...";
     attente_misalheure++;
  }	
  digitalClockDisplay();  
}

void digitalClockDisplay(){
// digital clock display of the time
Serial << ((day()<10)?"0":"") << day() << "/" << ((month()<10)?"0":"") << month() << "/" << ((year()<10)?"0":"") << year() << " ";
Serial << ((hour()<10)?"0":"") << hour() << ":" << ((minute()<10)?"0":"") << minute() << ":" << ((second()<10)?"0":"") << second() << " " << attente_misalheure << endl;

  lcd.setCursor( 0,0); 
  lcd << ((day()<10)?"0":"") << day() << "/" << ((month()<10)?"0":"") << month() << "/" << ((year()<10)?"0":"") << year();
  lcd.setCursor( 0,1); 
  lcd << ((hour()<10)?"0":"") << hour() << ":" << ((minute()<10)?"0":"") << minute() << ":" << ((second()<10)?"0":"") << second();
}

/*
void printDigits(int digits){
  // utility function for digital clock display: prints preceding colon and leading 0
  Serial.print(":");
  if(digits < 10)
    Serial.print('0');
  Serial.print(digits);
}
*/
